<?php

namespace DNB;

class Customer extends AbstractPostSerializable implements PostSerializableInterface {
    private string $name;
    private ?string $email;
    private string $mobilePhone;
    private ?string $zipCode;
    private ?string $comment;

    public function __construct(
        string $name,
        ?string $email,
        string $mobilePhone,
        ?string $zipCode = null,
        ?string $comment = null
    ) {
        $this->name = $name;
        $this->email = $email;
        $this->mobilePhone = $mobilePhone;
        $this->zipCode = $zipCode;
        $this->comment = $comment;
    }

    public function toPostParams(): array {
        $arr = [];

        foreach (static::getClassVars() as $key)
            if (!is_null($this->{$key}))
                $arr[$key] = $this->{$key};

        return $arr;
    }

    protected static function getClassVars(): array {
        return array_keys(get_class_vars(__CLASS__));
    }
}
